class Can
{
 

  Serial myPort;  // Create object from Serial class
  int val;      // Data received from the serial port
  int i = 0;
  int N = 5; //mv avg ammount
  float brushSize;
  float nozzle;
  String inBuffer;
 
  int minD = 20;  //min val back from can's distance sensor 
  int maxD = 150; //max value back...
 AudioPlayer spray;

  float[] nozzHist; 
  float[] distHist; 
  float avgNoz = 0;
  float avgDist = 0;

int lf = 13;      // ASCII linefeed

 Can( AudioPlayer sample, Serial tmyPort , int tminBrushSize, int tmaxBrushSize)
   {
     spray = sample;
    nozzHist = new float[N];
    distHist = new float[N];
    myPort = tmyPort;
    minBrushSize = tminBrushSize;
    maxBrushSize = tmaxBrushSize;  
    brushSize = tminBrushSize;
       myPort.bufferUntil(lf);
 
  }
 
int time;
int oldtime = 0;
int diff;
 
 void updateCan2( String inString )
 {
  time = millis();
  diff = time - oldtime;
  oldtime = time;
  
  String []list = split(inString, ' ' );
 
  int dist = unhex( list[2] );
  int nozz = unhex( list[1] );
  if( diff > 0 )
  {
  //  print( "freq: " + 1000 / diff + " dist: " + dist + " nozz: " + nozz + "\n" );
  }
  addToHistory( distHist, dist );
  avgDist = movingAverage( distHist );

  addToHistory( nozzHist, nozz );
  avgNoz = movingAverage( nozzHist );

  avgDist = constrain( avgDist, minD, maxD );
  brushSize = map( avgDist, minD, maxD, maxBrushSize, minBrushSize);

/*  if( nozz < 254 )
  {
      if( ! spray.isPlaying() ) spray.loop();
  }
  else
  {
    if( spray.isPlaying() ) spray.pause();
  }*/
// println( "nozz: " + avgNoz );
//   println( "bru raw: " + avgDist );
//   println( "bru map: " + brushSize );

}

  

  int stringToInt( String buffer )
  {
    i = 0;
    trim( buffer );
    for( int l = 0; l < buffer.length() - 1 ; l ++ )
    {

      i *= 10; 
      i += int( buffer.charAt( l ) ) - 48;


    } 
    return i;
  }

  int getBrushSize()
  {
    return (int)brushSize;
  }

  int getNozzle()
  {
    return (int)avgNoz;
    
  }
  int getOpacity()
  {
    if( getNozzle() < 150 ) return 255; 
    return (int)map( getNozzle(), 255, 150, 70, 255 );
  }


  void addToHistory( float [] hist, float newValue )
  {
    for( int i = 0; i < N - 1; i ++ )
    {
      hist[i] = hist[i+1];
    }
    hist[N - 1] = newValue;
  }
  
   
  float movingAverage( float [] hist )      
  {
    float sum = 0.0;
    for (int i = 0; i<N; i++)
    {
       sum += hist[i];
    }
    return sum / N;
  }

 
}


